import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

import java.util.*; //list, iterator classes
/**
 * Base enemy class including movement, destruction, and attacks.
 * 
 * @author Jake Fahrbach    
 * @version 0.6
 */
public class Enemy1  extends Actor
{
    /**
     * Act - do whatever the Enemy1 wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public int dir = 1; //1 = left 2 = right
    
    public int movetimer = 0; //timer value to move at cetain intervals
    
    public int shouldMove = 0; //weather or not they should move
    
    public int shouldCar = 0;
    
    public GreenfootImage img1; //1st animation
    
    public GreenfootImage img2; //2nd animation
    
    public int shoot; //variable to determine if wea should shoot or not. starting chance is 2%
    
    public int chance = 1; //chance to shoot, starts at 2%
    
    public Enemy1() //creation code, sets two variables with the two images
    {
        img1 = getImage(); //current image
        img2 = new GreenfootImage("enemy1-2.gif"); //second image
    }
    
    public void act() //main loop event, inherited from Actor class
    {
       List bullets = getNeighbours(3, false, Pbullet.class); //new list with all Pbullets within 2 uinits adjacent to the enemy
       if (!bullets.isEmpty()) { //is there is one (there will only be one, since only one bullet on screen at a time)
       Actor b = (Actor) bullets.get(0); //gets the first object in the list
       if (b instanceof Pbullet) { //just an extra check to make sure its a player bullet
           ((Space) getWorld()).ShootSet(1); //allow us to fire again
           getWorld().removeObject(b); //remobe the bullet
           destroy(); //call the destroy funcrtion
       }
       } else {
           shoot();
           move();    //if we are still alive move
       }
    }
    
    public void destroy() //desttroy functon
    {
        Greenfoot.playSound("invaderkilled.wav"); //sound
        ((Space) getWorld()).addPoints(10); //add points
        ((Space) getWorld()).invaders--;
        if (((Space)getWorld()).invaders <= 0) {
            ((Space) getWorld()).populate();
            ((Space)getWorld()).invaders = 50;
        }
        getWorld().removeObject(this); //remove the instance
    }
    
    public void shoot()
    {
        if (shouldMove == 1) {
            shoot = Greenfoot.getRandomNumber(100);
            if (shoot <= chance) {
                getWorld().addObject(new Ebullet(), getX(), getY()+5);
            }
        }
    }
        
        
    
    public void move() //move function, called in step
    {
        if (dir == 1 && shouldCar == 1) {
            if (getX() + 5 >= getWorld().getWidth()) { //if the next move would put us out of the map
                carridgeRight(); //call the carride function
                carridgeAlliesRight(); //bring our buddies
                movetimer = 0; //reset timer
                shouldMove = 0; //dont move
            }
        } else if (dir == 2 && shouldCar == 1) {
            if (getX() - 5 <= 0) {
                carridgeLeft();
                carridgeAlliesLeft();
                movetimer = 0;
                shouldMove = 0;
            }
        }
        if (dir == 1 && shouldMove == 1) { //if we are moving left and we can move
            if (getImage() == img1) { //change animation
                setImage(img2); 
            } else {
                setImage(img1);
            }
            setLocation(getX()+5, getY()); //move
            shouldMove = 0; //we cant move again yet
        } else if (dir == 2 && shouldMove == 1) { //same stuff as before
            if (getImage() == img1) {
                setImage(img2);
            } else {
                setImage(img1);
            }
            setLocation(getX()-5, getY()); //move
            shouldMove = 0;
        } else if (shouldMove == 0) { //if we cant move
            movetimer++; //add one to the timer
            if (movetimer == 24) {//if its at 24 steps
                shouldCar = 1; //check for caridge returns
            } else if (movetimer == 25) {
                shouldMove = 1; //we can move again
                shouldCar = 0; //dont want to caridge return now.
                movetimer = 0;
            }
        }
    }
    
    private void carridgeRight() //moving down and switching direction function
    {
        setLocation(getX(), getY() + 5); //move down
        dir = 2;//change direction
        chance = chance+1; //increases our chance to fire
        if (getY() > 60) {
            ((Space) getWorld()).gameOver();
        }
    }
    
    private void carridgeLeft()//same as above
    {
        setLocation(getX(), getY() + 5);
        dir = 1;
        chance = chance+1;
    }
    
    private void carridgeAlliesRight()//executes the preceding function on the other enemies
    {
        List allies = getWorld().getObjects(Enemy1.class);//list of all the other enemies
        Iterator i = allies.iterator();//create an iterator in that list
        while(i.hasNext()) {//if theres more enemies to move
            Enemy1 a = (Enemy1) i.next();//put the enemy into a variable
            if ( a != this) {//if they arent us (cuz we all ready moved)
                a.carridgeRight();//move them down
                a.setLocation(a.getX(), a.getY());
                a.shouldMove = 0;
                a.movetimer = 0;
                if (getImage() != a.getImage()) {
                    setImage(a.getImage());
                }
            }
        }
    }
    
    private void carridgeAlliesLeft()//same as above
    {
        List allies = getWorld().getObjects(Enemy1.class);
        Iterator i = allies.iterator();
        while(i.hasNext()) {
            Enemy1 a = (Enemy1) i.next();
            if ( a != this) {
                a.carridgeLeft();
                a.setLocation(a.getX(), a.getY());
                a.shouldMove = 0;
                a.movetimer = 0;
                if (getImage() != a.getImage()) {
                    setImage(a.getImage());
                }
            }
        }
    }
}
